package net.t2code.t2codelib.SPIGOT.api.messages;

import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.T2CupdateWebData;
import net.t2code.t2codelib.Util;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import java.util.List;

public class T2Ctemplate {


    public static Long onLoadHeader( String prefix, List<String> autor, String version, String spigot, String discord) {
        return onLoadHeader( prefix, autor, version, spigot, discord, null, null);
    }

    public static Long onLoadHeader(String prefix, List<String> autor, String version, String spigot, String discord, Boolean isPremium, Boolean isVerify) {
        Long long_ = System.currentTimeMillis();

        /**
         T2Csend.console(prefix + " <dark_red>  _______ </dark_red><gray>___   </gray><dark_red>_____ </dark_red>");
         T2Csend.console(prefix + " <dark_red> |__   __|</dark_red><gray>__ \\ </gray><dark_red>/ ____|</dark_red>");
         T2Csend.console(prefix + " <dark_red>    | |   </dark_red><gray>  ) </gray><dark_red>| |     </dark_red>");
         T2Csend.console(prefix + " <dark_red>    | |   </dark_red><gray> / /</gray><dark_red>| |     </dark_red>");
         T2Csend.console(prefix + " <dark_red>    | |   </dark_red><gray>/ /_</gray><dark_red>| |____ </dark_red>");
         T2Csend.console(prefix + " <dark_red>    |_|  </dark_red><gray>|____|</gray><dark_red>\\_____|</dark_red>");
         */


        for (String s : Util.getLoadLogo()) {
            T2Csend.console(prefix + " §e" + s);
        }
        setCenterAligned(prefix, "§2Author §6" + String.valueOf(autor).replace("[", "").replace("]", ""), true);
        setCenterAligned(prefix, "§2Version: §6" + version, true);
        setCenterAligned(prefix, "§2Spigot: §6" + spigot, true);
        setCenterAligned(prefix, "§2Discord: §6" + discord, true);
        if (isPremium != null) {
            if (isPremium) {
                setCenterAligned(prefix, "§6Premium: §2true", true);
            } else setCenterAligned(prefix, "§6Premium: §4false", true);
            if (isVerify != null) {
                if (isVerify) {
                    setCenterAligned(prefix, "§6Verify: §2true", true);
                } else setCenterAligned(prefix, "§6Verify: §4false", true);
            } else setCenterAligned(prefix, "§6Verify: §4false", true);
        }

        onLoadSeparateStroke(prefix);
        if (version.toLowerCase().contains("dev") || version.toLowerCase().contains("snapshot") || version.toLowerCase().contains("beta")) {
            setCenterAligned(prefix, "", true);
            setCenterAligned(prefix, "", true);
            setCenterAligned(prefix, "§eYou are running §4" + version + " §eof §4" + prefix + "§e!", true);
            setCenterAligned(prefix, "§eSome features may not be working as expected.", true);
            setCenterAligned(prefix, "§ePlease report all bugs here: http://dc.t2code.net", true);
            setCenterAligned(prefix, "§4UpdateChecker & bStats may be disabled!", true);
            setCenterAligned(prefix, "", true);
            setCenterAligned(prefix, "", true);
            onLoadSeparateStroke(prefix);

            try {
                Thread.sleep(2000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }

        return long_;
    }

    public static Long onLoadHeader(String prefix) {
        Long long_ = System.currentTimeMillis();
        T2Csend.console(prefix + "§4===================== " + prefix + " §4=====================");
        return long_;
    }

    public static void onLoadSeparateStroke(String prefix) {
        T2Csend.console(prefix + " §e╠═══════════════════════════════════════════════════════════════════════════╣");
    }


    public static void onLoadFooter(String prefix, Long long_, String v) {
        onLoadFooter(prefix, long_);
    }


    public static void onLoadFooter(String prefix, Long long_) {
        onLoadSeparateStroke(prefix);
        setCenterAligned(prefix, "§2Plugin loaded successfully." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms", true);
        T2Csend.console(prefix + " §e" + BOTTOM_BORDER);
    }

    public static void onDisable(String prefix, Plugin plugin) {
        sendFrameCenter(prefix, " §2Version: §6" + plugin.getDescription().getVersion(), "§2Autors: §6" + String.valueOf(plugin.getDescription().getAuthors()).replace("[", "").replace("]", ""), " §4Plugin successfully disabled. ");

    }

    public static void sendInfo(CommandSender sender, Plugin plugin, int spigotID, String discord, Boolean premiumVerified, String text) {
        String pluginVersion = plugin.getDescription().getVersion();
        String publicVersion = "";
        boolean update;
        String stNVersion;
        T2CupdateWebData webData;
        try {
            webData = T2CupdateAPI.pluginVersions.get(plugin.getName()).webData;
        } catch (Exception ex) {
            webData = null;
        }

        if (webData != null) {
            publicVersion = T2CupdateAPI.pluginVersions.get(plugin.getName()).webData.getVersion();
            update = !publicVersion.equalsIgnoreCase(pluginVersion);

        } else {
            update = false;
        }

        boolean player = sender instanceof Player;
        String stPlugin = "<dark_red>║</dark_red> <yellow>Plugin:</yellow> <gold>[pl]</gold>".replace("[pl]", plugin.getName());
        String stVersion = "<dark_red>║</dark_red> <yellow>Version:</yellow> <gold>[ver]</gold>".replace("[ver]", pluginVersion);
        String stAutor = "<dark_red>║</dark_red> <yellow>Autor(s):</yellow> <gold>[autor]</gold>".replace("[autor]", plugin.getDescription().getAuthors().toString());

        String stUpdate = "<dark_red>║</dark_red> <yellow>New version available:</yellow> [up]".replace("[up]", webData != null ? update ?
                "<dark_green>YES</dark_green>" : "<red>no</red>" : "<b><dark_red>It could not be checked for updates!</dark_red></b>");
        stNVersion = update ? "<br><dark_red>║</dark_red> <yellow>Newest Version:</yellow> <gold>[nver]</gold>".replace("[nver]", player ? "<hover:show_text:'<yellow>Click for the update information</yellow>'><click:run_command:'/t2code updateinfo " + plugin.getName() + "'>" + publicVersion + "</click></hover>" : publicVersion) : "";
        String stLinkPlayer = "<dark_red>║</dark_red> <yellow><hover:show_text:'<green>Go to the Spigot page</green>'><click:open_url:'[slink]'>Spigot</click></hover></yellow> "
                .replace("[slink]", "https://www.spigotmc.org/resources/" + spigotID)
                + "<dark_red>-</dark_red> <dark_purple><hover:show_text:'<green>Go to the T2Code Support Discord</green>'><click:open_url:'[dlink]'>Discord</click></hover></dark_purple>"
                .replace("[dlink]", discord);
        String stLinkConsole = "<dark_red>║</dark_red> <yellow>Spigot:</yellow> <gold>https://www.spigotmc.org/resources/" + spigotID + "</gold>"
                + "<br><dark_red>║</dark_red> <yellow>Discord:</yellow> <gold>" + discord + "</gold>";
        String stLink = player ? stLinkPlayer : stLinkConsole;
        String pr = premiumVerified != null ? "<br><dark_red>║</dark_red> <yellow>Premium verified:</yellow> [pr]".replace("[pr]",
                premiumVerified ? "<dark_green>YES</dark_green>" : "<red>NO</red>") : "";

        String stMSG = text == null || text.equals("") ? "" : "<br><dark_red>║</dark_red> " + text;
        T2Csend.sender(sender, "<br><dark_red>╔════════════════════════════════</dark_red>"
                + "<br>" + stPlugin
                + "<br>" + stVersion
                + stMSG
                + "<br>" + stAutor
                + "<br>" + stUpdate
                + stNVersion
                + "<br>" + stLink
                + pr
                + "<br><dark_red>╚════════════════════════════════</dark_red>");
    }

    public static void sendInfo(CommandSender sender, Plugin plugin, int spigotID, String discord, String text) {
        sendInfo(sender, plugin, spigotID, discord, null, text);
    }


    // Frame in Console

    protected static final String BOTTOM_BORDER = "╚═══════════════════════════════════════════════════════════════════════════╝";
    protected static final int FIXED_WIDTH = BOTTOM_BORDER.length() - 2; // Länge ohne die Randzeichen


    public static void setCenterAligned(String prefix, String text, boolean setStartFrame) {
        if (!setStartFrame) {
            T2Csend.console(prefix + " " + text);
            return;
        }
        // Entfernen von Farbcodes aus der Berechnungslänge
        String textWithoutColor = removeColorCodes(text);
        int textLengthWithoutColor = textWithoutColor.length();
        int totalPaddingSize = FIXED_WIDTH - textLengthWithoutColor;

        // Sicherstellen, dass das Padding nicht negativ wird
        if (totalPaddingSize < 0) totalPaddingSize = 0;

        // Berechnung des Abstands vor und nach dem Text
        int paddingLeft = totalPaddingSize / 2;
        int paddingRight = totalPaddingSize - paddingLeft;
        // Formatierung der Zeile: Text zentrieren
        String formattedValue = "§e║" + " ".repeat(paddingLeft) + text + " ".repeat(paddingRight) + "§e║";
        T2Csend.console(prefix + " " + formattedValue);
    }


    public static void setLeftAligned(String prefix, String text, boolean setStartFrame) {
        T2Csend.error(T2CodeLibMain.getPlugin(), text);
        if (!setStartFrame) {
            T2Csend.console(prefix + " " + text);
            return;
        }
        // Entfernen von Farbcodes aus der Berechnungslänge
        String textWithoutColor = removeColorCodes(text);
        int textLengthWithoutColor = textWithoutColor.length();
        int totalPaddingSize = FIXED_WIDTH - textLengthWithoutColor;

        // Sicherstellen, dass das Padding nicht negativ wird
        if (totalPaddingSize < 0) totalPaddingSize = 0;

        // Berechnung des Abstands nach dem Text und vor dem Rand
        int paddingLeft = 0; // Kein zusätzlicher Abstand vor dem Text
        int paddingRight = totalPaddingSize; // Alles Padding geht nach rechts

        // Formatierung der Zeile: Text am Anfang und dynamischer Abstand zum Ende
        String formattedValue = "§e║" + text + " ".repeat(paddingRight) + "║";
        T2Csend.console(prefix + " " + formattedValue);

    }


    // Methode für mehrere Zeilen Text mit dynamischem Rahmen
    public static void sendFrameLeft(String prefix, String... lines) {

        String COLOR_CODE = "§e";
        String BORDER_CHAR = "═";
        String TOP_LEFT = "╔";
        String TOP_RIGHT = "╗";
        String BOTTOM_LEFT = "╚";
        String BOTTOM_RIGHT = "╝";
        String SIDE_BORDER = "║";

        // Entfernen von Farbcodes und Berechnung der maximalen Länge
        int maxLength = 0;
        for (String line : lines) {
            String lineWithoutColor = removeColorCodes(line);
            maxLength = Math.max(maxLength, lineWithoutColor.length());
        }

        // Berechnung der Rahmenbreite
        int frameWidth = maxLength + 2; // +2 für die Ränder '║'
        String topBorder = COLOR_CODE + TOP_LEFT + BORDER_CHAR.repeat(frameWidth) + COLOR_CODE + TOP_RIGHT;
        String bottomBorder = COLOR_CODE + BOTTOM_LEFT + BORDER_CHAR.repeat(frameWidth) + COLOR_CODE + BOTTOM_RIGHT;



        // Gehe durch jede Zeile und formatiere sie
        StringBuilder builder = new StringBuilder();

        // Ausgabe der oberen Linie
        builder.append("<br>").append(prefix).append(" ").append(topBorder).append("<br>");
        for (String line : lines) {
            // Entfernen von Farbcodes aus der Berechnungslänge
            String lineWithoutColor = removeColorCodes(line);
            int lineLengthWithoutColor = lineWithoutColor.length();
            int totalPaddingSize = frameWidth - lineLengthWithoutColor; // -2 für die Ränder '║'

            // Sicherstellen, dass das Padding nicht negativ wird
            if (totalPaddingSize < 0) totalPaddingSize = 0;

            // Berechnung des Abstands nach dem Text und vor dem Rand
            int paddingLeft = 0; // Kein zusätzlicher Abstand vor dem Text
            int paddingRight = totalPaddingSize; // Alles Padding geht nach rechts

            // Formatierung der Zeile: Text am Anfang und dynamischer Abstand zum Ende
            String formattedValue = COLOR_CODE + SIDE_BORDER + line + " ".repeat(paddingRight) + COLOR_CODE + SIDE_BORDER;
            builder.append(prefix).append(" ").append(formattedValue).append("<br>");
        }
        // Ausgabe der unteren Linie
        builder.append(prefix).append(" ").append(bottomBorder);
        T2Csend.console(builder.toString());
    }

    public static void sendFrameCenter(String prefix, String... lines) {

        String COLOR_CODE = "§e";
        String BORDER_CHAR = "═";
        String TOP_LEFT = "╔";
        String TOP_RIGHT = "╗";
        String BOTTOM_LEFT = "╚";
        String BOTTOM_RIGHT = "╝";
        String SIDE_BORDER = "║";
        // Entfernen von Farbcodes und Berechnung der maximalen Länge
        int maxLength = 0;
        for (String line : lines) {
            String lineWithoutColor = removeColorCodes(line);
            maxLength = Math.max(maxLength, lineWithoutColor.length());
        }

        // Berechnung der Rahmenbreite
        int frameWidth = maxLength + 2; // +2 für die Ränder '║'
        String topBorder = COLOR_CODE + TOP_LEFT + BORDER_CHAR.repeat(frameWidth) + COLOR_CODE + TOP_RIGHT;
        String bottomBorder = COLOR_CODE + BOTTOM_LEFT + BORDER_CHAR.repeat(frameWidth) + COLOR_CODE + BOTTOM_RIGHT;

        
        // Gehe durch jede Zeile und formatiere sie
        StringBuilder builder = new StringBuilder();

        // Ausgabe der oberen Linie

        builder.append("<br>").append(prefix).append(" ").append(topBorder).append("<br>");
        for (String line : lines) {
            // Entfernen von Farbcodes aus der Berechnungslänge
            String lineWithoutColor = removeColorCodes(line);
            int lineLengthWithoutColor = lineWithoutColor.length();
            int totalPaddingSize = frameWidth - lineLengthWithoutColor; // -2 für die Ränder '║'

            // Sicherstellen, dass das Padding nicht negativ wird
            if (totalPaddingSize < 0) totalPaddingSize = 0;

            // Berechnung des Abstands vor und nach dem Text
            int paddingLeft = totalPaddingSize / 2;
            int paddingRight = totalPaddingSize - paddingLeft;

            // Formatierung der Zeile: Text zentrieren
            String formattedValue = COLOR_CODE + SIDE_BORDER + " ".repeat(paddingLeft) + line + " ".repeat(paddingRight) + COLOR_CODE + SIDE_BORDER;
            builder.append(prefix).append(" ").append(formattedValue).append("<br>");

        }
        // Ausgabe der unteren Linie
        builder.append(prefix).append(" ").append(bottomBorder);
        T2Csend.console(builder.toString());

    }

    // Methode zum Entfernen von Farbcodes und MiniMessage-Farbcodes aus dem Text, außer <br>
    private static String removeColorCodes(String text) {
        // Regex für alle Farbcodes und MiniMessage-Codes außer <br>
        String miniMessageRegex = "<(?!br)(color:#([A-Fa-f0-9]{6})|[a-zA-Z_]+)(:[a-zA-Z0-9_]+)?>|</[a-zA-Z_]+>";
        return text.replaceAll("§[a-f0-9k-oK-O]", "").replaceAll(miniMessageRegex, "");
    }

}